diff -ur nagios-4.0.20130107/cgi/cgiutils.c nagios-4.0.20130107.cgis/cgi/cgiutils.c
--- nagios-4.0.20130107/cgi/cgiutils.c	2013-01-08 04:57:06.000000000 +0000
+++ nagios-4.0.20130107.cgis/cgi/cgiutils.c	2013-01-08 04:54:59.000000000 +0000
@@ -461,6 +464,13 @@
 			strip(log_file);
 			}
 
+        else if(strstr(input, "object_cache_file=") == input) {
+			temp_buffer = strtok(input, "=");
+			temp_buffer = strtok(NULL, "\x0");
+            //printf("Reading object_cache_file=%s\n",temp_buffer);
+            object_cache_file = nspath_absolute(temp_buffer, config_file_dir);
+            }
+
 		else if(strstr(input, "log_archive_path=") == input) {
 			temp_buffer = strtok(input, "=");
 			temp_buffer = strtok(NULL, "\n");
diff -ur nagios-4.0.20130107/t/etc/nagios.cfg nagios-4.0.20130107.cgis/t/etc/nagios.cfg
--- nagios-4.0.20130107/t/etc/nagios.cfg	2012-12-24 15:29:55.000000000 +0000
+++ nagios-4.0.20130107.cgis/t/etc/nagios.cfg	2013-01-08 04:06:34.000000000 +0000
@@ -1,20 +1,20 @@
-log_file=var/nagios.log
+log_file=../var/nagios.log
 cfg_file=minimal.cfg
-object_cache_file=var/objects.cache
-precached_object_file=var/objects.precache
+object_cache_file=../var/objects.cache
+precached_object_file=../var/objects.precache
 resource_file=etc/resource.cfg
-status_file=var/status.dat
+status_file=../var/status.dat
 status_update_interval=10
 nagios_user=nagios
 nagios_group=nagios
 check_external_commands=1
-command_file=var/rw/nagios.cmd
-lock_file=var/nagios.lock
-temp_file=var/nagios.tmp
+command_file=../var/rw/nagios.cmd
+lock_file=../var/nagios.lock
+temp_file=../var/nagios.tmp
 temp_path=/tmp
 event_broker_options=-1
 log_rotation_method=d
-log_archive_path=var/archives
+log_archive_path=../var/archives
 use_syslog=1
 log_notifications=1
 log_service_retries=1
@@ -31,7 +31,7 @@
 max_concurrent_checks=0
 check_result_reaper_frequency=10
 max_check_result_reaper_time=30
-check_result_path=var/spool/checkresults
+check_result_path=../var/spool/checkresults
 max_check_result_file_age=3600
 cached_host_check_horizon=15
 cached_service_check_horizon=15
@@ -48,7 +48,7 @@
 ocsp_timeout=5
 perfdata_timeout=5
 retain_state_information=1
-state_retention_file=var/retention.dat
+state_retention_file=../var/retention.dat
 retention_update_interval=60
 use_retained_program_state=1
 use_retained_scheduling_info=1
@@ -97,5 +97,5 @@
 enable_environment_macros=1
 debug_level=0
 debug_verbosity=1
-debug_file=var/nagios.debug
+debug_file=../var/nagios.debug
 max_debug_file_size=1000000
--- nagios-4.0.20130107.cgis/t/var/objects.cache	2012-12-24 15:29:53.000000000 +0000
+++ nagios-4.0.20130107/t/var/objects.cache	2013-01-08 05:18:58.000000000 +0000
@@ -29,6 +29,12 @@
 	}
 
 define contactgroup {
+	contactgroup_name	normalhostcontactgroup
+	alias	This contact group is assigned to a host normally
+	members	second
+	}
+
+define contactgroup {
 	contactgroup_name	empty
 	alias	No members defined - this should pass validation
 	}
@@ -69,6 +75,7 @@
 	address	192.168.1.1
 	check_period	none
 	contacts	nagiosadmin
+	contact_groups normalhostcontactgroup
 	notification_period	none
 	initial_state	o
 	check_interval	5.000000
@@ -131,6 +138,7 @@
 	check_period	none
 	check_command	check_me
 	contacts	nagiosadmin
+	contact_groups normalhostcontactgroup
 	notification_period	none
 	initial_state	o
 	check_interval	32.000000
--- nagios-4.0.20130107.cgis/t/610cgistatus.t	2012-12-24 15:29:55.000000000 +0000
+++ nagios-4.0.20130107/t/610cgistatus.t	2013-01-08 05:19:04.000000000 +0000
@@ -15,7 +15,7 @@
 
 my $output;
 
-plan tests => 8;
+plan tests => 9;
 
 my $numhosts;
 
@@ -29,11 +29,11 @@
 
 $output = `NAGIOS_CGI_CONFIG=etc/cgi.cfg REMOTE_USER=nagiosadmin REQUEST_METHOD=GET QUERY_STRING=host=host1 $cgi`;
 like( $output, '/status.cgi\?host=host1&sorttype=1&sortoption=1/', "Host value should be set to specific host if passed in" );
-like( $output, '/1 Matching Service Entries Displayed/', "Found the one host" );
+like( $output, '/1 Matching Services/', "Found the one host" );
 
 $output = `NAGIOS_CGI_CONFIG=etc/cgi.cfg REMOTE_USER=nagiosadmin REQUEST_METHOD=GET QUERY_STRING=host= $cgi`;
 like( $output, '/status.cgi\?host=&sorttype=1&sortoption=1/', "Host value kept as blank if set to blank" );
-like( $output, '/0 Matching Service Entries Displayed/', "Got no hosts because looking for a blank name" );
+like( $output, '/0 Matching Services/', "Got no hosts because looking for a blank name" );
 
 $output = `NAGIOS_CGI_CONFIG=etc/cgi.cfg REMOTE_USER=nagiosadmin REQUEST_METHOD=GET $cgi`;
 like( $output, '/status.cgi\?host=all&sorttype=1&sortoption=1/', "Host value should be set to all if nothing set initially" );
@@ -41,3 +41,6 @@
 $_ = grep /title=/, split("\n", $output);
 is( $_, $numhosts, "Same number of hosts" );
 
+$output = `NAGIOS_CGI_CONFIG=etc/cgi.cfg REMOTE_USER=second REQUEST_METHOD=GET QUERY_STRING=host=all $cgi`;
+like( $output, '/1 Matching Services/', "Got 1 service, as permission only allows one host");
+
